module Abbrevs where 

import Tct.Interactive
import Tct.Instances
import qualified Termlib.Repl as TR

whenNonTrivial t = withProblem $ \ prob ->
  when (not $ TR.isEmpty $ TR.strictComponents prob) t
  
wg dim deg = weightgap 
             `withCertBy` cert' 
             `withDimension` dim' 
             `withDegree` deg' 
             `withCBits` Just (bits' + 1) 
             `withBits` bits'
             `wgOn` WgOnAny
  where bits' | dim <= 3  = 2
              | otherwise = 1
        dim' = max 1 dim
        deg' = if dim' <= deg then Nothing else Just (max 0 deg)
        cert' | deg' == Just 0 = Algebraic
              | otherwise = Automaton

mx dim deg = matrix 
             `withCertBy` cert' 
             `withDimension` dim' 
             `withDegree` deg' 
             `withCBits` Just (bits' + 1) 
             `withBits` bits'
  where bits' | dim <= 2  = 2
              | otherwise = 1
        dim' = max 1 dim
        deg' = if dim' <= deg then Nothing else Just (max 0 deg)
        cert' | deg' == Just 0 = Algebraic
              | otherwise = Automaton
                      
matchbounds = bounds Minimal Match `orFaster` bounds PerSymbol Match

spopstar = popstarSmallPS . Just                    

matrices i = fastest [ mx i i, mx (i + 2) i]

simps = 
  te removeHeads
  >>> try cleanTail
  >>> try trivial
  >>> try usableRules 

basics = 
  timeout 5 matchbounds 
  `orFaster` (te (trivial <||> (sems >>> try simps)) >>! popstars)
  where
    sems =  
      pe (polys 3)
      <||> pe (mx 3 3)
      <||> pe (mx 4 3)                        
      <||> pe (mx 4 4)
    popstars = popstarPS `before` popstar
    pe proc = proc `withPEOn` selAnyOf selStricts
