module Raml where 

import Tct.Interactive
import Tct.Instances hiding (toDP)
import qualified Termlib.Repl as TR
import Tct.Configuration

import Abbrevs
  

toDP = 
  dependencyTuples
  >>> try removeInapplicable
  >>> try simpDP

simpDP = 
  te removeHeads
  >>> try cleanTail
  >>> try (exhaustively partitionIndependent >>> try cleanTail)
  >>> try trivial
  >>> try usableRules 

cleanUpTail = 
  (removeTails >>> try simpDPRHS)
  >>> try usableRules
  >>> try trivial  

semantic smallbits bigbits i = whenNonTrivial $ 
  peAny (spopstar i)
  <||> when bigbits 
       (peAny (mx i i)                
        <||> peAny (mx (i + 1) i)
        <||> when (i == 2) (peAny (polys 2)))
  <||> when smallbits 
       (peAny (withSB $ mx i i) 
        <||> peAny (withSB $ mx (i + 1) i)
        <||> when (i <= 2) (peAny (withSB $ mx (i + 2) i))
        <||> when (i == 2) (peAny (withSB $ polys 2)))
  where withSB m = m `withBits` 1 `withCBits` Just 2
        peAny p = p `withPEOn` selAnyOf (selLeafCWDG `selInter` selStricts)
                  >>> try cleanUpTail

semantic' = semantic True True 

        -- shiftDPs = timed $ 
        --   te (rl 0)
        --   >>> te (withTO $ shift maxdeg)
        -- shift 0 = some $ idtrans
        -- shift 1 = some $ rl 1 
        -- shift n = some $ shift (n - 1) <> rl n
        -- rl 0 = whenNonTrivial $ removeLeaf (mx 1 0)
        -- rl i = whenNonTrivial $ 
        --        removeLeaf (spopstar i)
        --        <||> removeLeaf (mx i i)                
        --        <||> removeLeaf (mx (i + 1) i)
        --        <||> removeLeaf (smallbits $ mx i i) 
        --        <||> removeLeaf (smallbits $ mx (i + 1) i)
        --        <||> when (i <= 2) (removeLeaf (smallbits $ mx (i + 2) i))
        --        <||> when (i == 2) (removeLeaf (polys 2))
        --        <||> when (i == 2) (removeLeaf (smallbits $ polys 2))               
        -- smallbits m = m `withBits` 1 `withCBits` Just 2



semantics smallbits bigbits maxdeg maybeTO = 
  te (rl 0)
  >>> te (withTO $ shiftRules)
  where
    shiftRules = shift maxdeg
    shift 0 = some $ idtrans
    shift 1 = some $ rl 1 
    shift n = some $ shift (n - 1) <> rl n
    
    rl = semantic smallbits bigbits  
                    
    withTO t = maybe (some t) (\ (Nat n) -> some $ timeout n t) maybeTO

-- semantics smallbits bigbits maxdeg maybeTO = rl 1
--   where
--     rl i 
--       | i <= maxdeg = some $ try $ whenNonTrivial $ 
--         (withTO (semantic smallbits bigbits i)
--          >>> try ((cleanUpTail >>> try (rl 1)) <>  rl i))
--         <> rl (i + 1)
--       | otherwise = some $ try idtrans
                    
--     withTO t = maybe (some t) (\ (Nat n) -> some $ timeout n t) maybeTO

semantics' = semantics True True 2 (Just 20)

decomposeFC smallbits bigbits maxdeg maybeTO = 
  timed $ 
  decomposeDG decomposeDGselect `solveUpperWith` (try simpDPRHS 
                                                  >>> try simpDP 
                                                  >>> try shiftDPs 
                                                  >>!! basics) 
  >>> try partitionIndependent >>> try simpDP 
  where 
    shiftDPs = semantics smallbits bigbits maxdeg maybeTO
  
decomposeFC' maxdeg = decomposeFC True True maxdeg (Just 20)

raml (maybeTO :+: greedy :+: smallbits :+: bigbits :+: Nat maxdeg) = 
  toDP >>!! timed decomposing
  where 
    decomposing 
      | greedy = some $ 
                 te decomp >>> try shiftDPs >>!! basics
      | otherwise = some $ 
                    try shiftDPs >>!! iteProgress decomp decomposing basics
      where 
        shiftDPs = semantics smallbits bigbits maxdeg maybeTO
        decomp = decomposeFC smallbits bigbits maxdeg maybeTO
